<?php
/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Apr 15, 2014
 * @version $Rev$
 */

class Entity_Form_ForgotPassword {
    private $interfacer = null;
    
    private $required_fields = array('email');
    
    public function __construct() 
    {
        $this->interfacer =  WP_Interfacer::getInstance() ;
    }
    
    public function display($params = array())
    {
        $input_data = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
        $labels = Utils_Labels::get();
        $errors = array();
        $data = array();
        $general_error = false;
        if($input_data !== NULL && wp_verify_nonce($input_data['_carerix_nonce_field'], 'forgotpwd')) {
            foreach($this->required_fields as $name)
			{
				if(  isset($input_data[$name]) 
					&& strlen(trim($input_data[$name]) ) == 0 ) 
				{
                    $errors[$name] = $labels['CxFinder.message.error.pageContent'];
				}
			}
            
            if(count($errors) == 0) 
            {
                $email = $input_data['email'];
                $employees = Carerix_Api_Rest_Entity_CREmployee::findAll(array(
                    'show' => array('toUser.emailAddresses', 'toUser.userName', 'toUser.isActive'),
                    'qualifier' => "toUser.emailAddresses.emailAddress = '$email' "
                ));

                $employee = null;
                foreach($employees as $_emp) {
                    $employee = $_emp;
                    break;
                }
                $exception = false;
                if($employee !== null) {
                    $parameters = array(
                        'emailtemplate' => 'forgotpwd',
                        'name' => '',
                        'ID' => (int)$employee->getId()
                    );
                    try {
                        $employee->email($parameters);
                        $data['succesful'] = true;
                    } catch (Carerix_Api_Rest_Exception $care) {
                        $general_error = $care->getMessage();
                        $exception = $care;
                    } catch (Exception $ex) {
                        $general_error = $ex->getMessage();
                        $exception = $ex;
                    }
                    if($exception) 
                    {
                        Utils_Log::write('FORGOTPASSWORD', $employee, $exception);
                        $general_error = $labels['CxPortal.message.error.templateNoRequestPassword'];
                    }
                } else {
                    $general_error = $labels['CxPortal.message.error.requestEmailNotFound'];
                }
            }
            
            
        }
        $data['general_error'] = $general_error;
        $data['errors'] = $errors;        
        $data['labels'] = $labels;

        $template = new Utils_Template('frontend/forms/forgotpwd');
        ob_start();
        $template->with($data)->display();
        $output = ob_get_contents();
        ob_end_clean();
        
        echo $output;
    }
            
}

?>
